<?php
///
// Isolde (Revision r168core-r128app)
//
// A third party package for CodeIgniter
//
// Copyright (c) 2013 Kenta Saito (gatedruid.com)
// License       MIT License (See ../isolde_license.txt)
//
?>
<?php
foreach ($config['actors'] as $actor)
{
	$actor_s = $actor == 'default' ? '' : $actor.'/';
	$actor_t = $actor.'/';

	//// Welcome
	if ($actor != 'default') // By CodeIgniter issue, controllers/default/welcome won't be loaded.
	{
		if (file_exists(APPPATH."controllers/{$actor}/welcome.php"))
		{
			$route[$actor] = $actor_s.'welcome';
		}
		else
		{
			$route[$actor] = 'welcome';
		}
	}

	//// Summary
	if (in_array($actor, $config['summary']))
	{
		if ( ! file_exists(APPPATH."controllers/{$actor}/summary.php"))
		{
			$route[$actor_s.'summary'] = 'summary';
		}
		else
		{
			$route[$actor_s.'summary'] = $actor_t.'summary';
		}
	}

	//// Auth
	if (in_array($actor, $config['authentication']))
	{
		if (file_exists(APPPATH."controllers/{$actor}/auth.php"))
		{
			$route[$actor_s.'auth/(:any)'] = $actor_t.'auth/$1';
			$route[$actor_s.'auth'] = $actor_t.'auth';
		}
		else
		{
			$route[$actor_s.'auth/(:any)'] = 'auth/$1';
			$route[$actor_s.'auth'] = 'auth';
		}
	}

	//// CRUD
	foreach ($config['targets'][$actor] as $target)
	{
		if (file_exists(APPPATH."controllers/{$actor}/{$target}.php"))
		{
			$route[$actor_s.$target.'/(:any)/(:any)'] = $actor_t.$target.'/$1/$2';
			$route[$actor_s.$target.'/(:any)'] = $actor_t.$target.'/$1';
			$route[$actor_s.$target] = $actor_t.$target.'/index';
		}
		else if (file_exists(APPPATH."controllers/{$target}.php"))
		{
			$route[$actor_s.$target.'/(:any)/(:any)'] = $target.'/$1/$2';
			$route[$actor_s.$target.'/(:any)'] = $target.'/$1';
			$route[$actor_s.$target] = $target.'/index';
		}
		else if (file_exists(APPPATH."controllers/{$actor}/crud.php"))
		{
			$route[$actor_s.$target.'/(:any)/(:any)'] = $actor_t.'crud/$1/$2/'.$target;
			$route[$actor_s.$target.'/(:any)'] = $actor_t.'crud/$1//'.$target;
			$route[$actor_s.$target] = $actor_t.'crud/index//'.$target;
		}
		else
		{
			$route[$actor_s.$target.'/(:any)/(:any)'] = 'crud/$1/$2/'.$target;
			$route[$actor_s.$target.'/(:any)'] = 'crud/$1//'.$target;
			$route[$actor_s.$target] = 'crud/index//'.$target;
		}
	}
}
