<?php
///
// Isolde (Revision r168core-r128app)
//
// A third party package for CodeIgniter
//
// Copyright (c) 2013 Kenta Saito (gatedruid.com)
// License       MIT License (See ../../../isolde_license.txt)
//
?>
<?php
// Shorten
if ( ! function_exists('shorten_if_required'))
{
	function shorten_if_required($vars, $value)
	{
		$label = $value;
		if (isset($vars->options) && in_array('shorten', $vars->options))
		{
			$label = strip_tags($label);
			$label = mb_substr($label, 0, 16);
			if (mb_strlen($value) > 16)
			{
				$label .= '...';
			}
		}
		return $label;
	}
}

// Choice
$CI =& get_instance();
if (isset($CI->config->item('choice')[$vars->key]))
{
	if (is_null($vars->value))
	{
		return;
	}

	$choice = $CI->config->item('choice')[$vars->key];
	$query =
		"SELECT {$choice[2]} AS c_label FROM {$choice[0]} WHERE {$choice[1]} = {$vars->value}";
	;
	$label = $CI->db->query($query)->row()->c_label;
	$label = shorten_if_required($vars, $label);

	if (in_array($vars->belongs_to, $isolde->config->targets[$isolde->segments->actor]))
	{
		echo '<a href="'.href("{$vars->belongs_to}/view/{$vars->value}", TRUE).'">';
		echo $label;
		echo '</a>';
	}
	else
	{
		echo $label;
	}

	return;
}

// Default
$label = shorten_if_required($vars, $vars->value);
$label = htmlspecialchars($label);

if (isset($vars->field->DATA_TYPE))
{
	// File
	if ($vars->field->DATA_TYPE == 'file')
	{
		$field = preg_replace('/_name$/', '', $vars->key);
		$href = href("{$vars->segments->target}/file/{$vars->row->id}?field={$field}", TRUE);
		if (preg_match('/^image\//', $vars->row->{$field.'_type'}))
		{
			$label .= '<br /><img src="'.$href.'&thumb=1" class="img-thumbnail" />';
		}
		$label = '<a href="'.$href.'">'.$label.'</a>';
	}
	// Text
	if ($vars->field->DATA_TYPE == 'text' && ! (isset($vars->options) && in_array('shorten', $vars->options)))
	{
		$label = nl2br(htmlspecialchars($vars->value));
	}
	// Datetime
	else if ($vars->field->DATA_TYPE == 'datetime')
	{
		if (isset($vars->options) && in_array('shorten', $vars->options))
		{
			$label = date('Y年m月d日', strtotime($vars->value));
		}
		else
		{
			$label = date('Y年m月d日 H時i分', strtotime($vars->value));
		}
	}
	// Date
	else if ($vars->field->DATA_TYPE == 'date')
	{
		$label = date('Y年m月d日', strtotime($vars->value));
	}
	// Time
	else if ($vars->field->DATA_TYPE == 'time')
	{
		$label = date('H時i分', strtotime($vars->value));
	}
	// Number
	else if ($vars->field->NUMERIC_PRECISION)
	{
		$label = '<div style="'.(isset($vars->options) && in_array('shorten', $vars->options) ? '' : ' width: 5em;').'text-align: right;">'.$vars->value.'</div>';
	}
}

if ($vars->segments->action == 'index' && in_array($vars->key, array('id', 'name', 'login')) && in_array('view', $vars->actions))
{
	$label = '<a href="'.href("{$vars->segments->target}/view/{$vars->row->id}", TRUE).'">'.$label.'</a>';
}

echo $label;
?>
